package org.dromara.work.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.work.domain.TpOrderPay;
import org.dromara.work.domain.bo.TpOrderPayBo;
import org.dromara.work.domain.vo.TpOrderPayVo;
import org.dromara.work.mapper.TpOrderPayMapper;
import org.dromara.work.service.ITpOrderPayService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 订单支付记录Service业务层处理
 *
 * @author Maosw
 * @date 2024-08-12
 */
@RequiredArgsConstructor
@Service
public class TpOrderPayServiceImpl implements ITpOrderPayService {

    private final TpOrderPayMapper baseMapper;

    /**
     * 查询订单支付记录
     *
     * @param id 主键
     * @return 订单支付记录
     */
    @Override
    public TpOrderPayVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询订单支付记录列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 订单支付记录分页列表
     */
    @Override
    public TableDataInfo<TpOrderPayVo> queryPageList(TpOrderPayBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpOrderPay> lqw = buildQueryWrapper(bo);
        Page<TpOrderPayVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的订单支付记录列表
     *
     * @param bo 查询条件
     * @return 订单支付记录列表
     */
    @Override
    public List<TpOrderPayVo> queryList(TpOrderPayBo bo) {
        LambdaQueryWrapper<TpOrderPay> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpOrderPay> buildQueryWrapper(TpOrderPayBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpOrderPay> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getOid() != null, TpOrderPay::getOid, bo.getOid());
        lqw.eq(StringUtils.isNotBlank(bo.getOrderId()), TpOrderPay::getOrderId, bo.getOrderId());
        lqw.eq(bo.getPrice() != null, TpOrderPay::getPrice, bo.getPrice());
        lqw.eq(bo.getState() != null, TpOrderPay::getState, bo.getState());
        lqw.eq(bo.getAddTime() != null, TpOrderPay::getAddTime, bo.getAddTime());
        lqw.eq(StringUtils.isNotBlank(bo.getTransactionId()), TpOrderPay::getTransactionId, bo.getTransactionId());
        return lqw;
    }

    /**
     * 新增订单支付记录
     *
     * @param bo 订单支付记录
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpOrderPayBo bo) {
        TpOrderPay add = MapstructUtils.convert(bo, TpOrderPay.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改订单支付记录
     *
     * @param bo 订单支付记录
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpOrderPayBo bo) {
        TpOrderPay update = MapstructUtils.convert(bo, TpOrderPay.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpOrderPay entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除订单支付记录信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
